module Btemplater
  module SuperHelper
    # extend EditHelper
    # include Btemplater::ApplicationHelper
    # include Btemplater::IndexHelper
    # include Btemplater::IndexSubHelper
    # include Btemplater::ShowHelper
    # include Btemplater::EditHelper
    # include Btemplater::Tools
    # include ActionView::Context
    # include ActionView::Helpers::FormHelper
    # include MetaTags::ViewHelper
    # include SimpleForm::ActionViewExtensions::FormHelper


    def superindex(columns, options = {}, context)
      context.instance_variable_set(:@virtual_path, "#{options[:class].last.name.to_s.tableize.sub('/', '.')}.index")
      code = Proc.new do
        do_index(
          {
            title: context.t('.title'),
            # rowclass: lambda { |d| d.unread ? 'unread' : 'read' },
            columns: columns,
            items: options[:objects],
            model: options[:class],
            actions: options[:actions]
          }.merge(options)
        )
      end
      eval 'self', code.binding
      context.instance_eval &code
    end

    def supershow(columns, options = {})
      edit_code = Proc.new {Btemplater::IndexSubHelper.edit_action(nil, @object, "#{@object.class.name}Policy".constantize.new(@current_user_obj, @object).edit?)}
      eval 'self', edit_code.binding

      do_show({
        title: @object.title,
        columns: columns,
        # my_content: 'show_content',
        item: @object,
        model: @object.class,
        url: options[:back_url],
        no_back: true,
        titleactions: [
          env.instance_eval(&edit_code)#,
          # edit_action(nil, @object, "#{@object.class}Policy".constantize.new(current_user, @object).edit?),
          # destroy_action(nil, @object, "#{@object}" + Policy.new(current_user, @object).destroy?)
        ],
        actions: [
          # (link_to(conrateblogs.new_blog_post_path(@object), class: 'btn btn-primary') do
          #   "<span class=\"fa fa-plus-square\"></span> #{t('.new_post')}".html_safe
          # end if("#{@object.class.name}Policy".constantize.new(@current_user_obj, @object).new?))
        ]
      }, env)
    end

    def supernew(columns, options = {}, context)
      skip_policy_scope
      skip_authorization

      context.instance_variable_set(:@virtual_path, "#{options[:obj].last.class.name.to_s.tableize.sub('/', '.')}.new")
      @object ||= options[:obj].last
      if options[:policy_class].blank?
        authorize @object
      else
        raise Pundit::NotAuthorizedError unless "#{options[:policy_class]}Policy".constantize.new(Current, options[:security_items] || @object).send("#{context.action_name}?")
      end
      code = Proc.new do
        do_new({
          title: context.t('.title'),
          columns: columns,
          item: @object,
          model: @object.class,
          url: polymorphic_url((options[:obj].nil? || options[:obj] == [nil]) ? @object : options[:obj]),
          back_url: options[:back_url].nil? ? url_for(action: :index) : options[:back_url],
          method: :post
        }.merge(options))
      end
      eval 'self', code.binding
      context.instance_eval &code
    end

    def superedit(columns, options = {}, context)
      skip_policy_scope
      skip_authorization
      
      context.instance_variable_set(:@virtual_path, "#{options[:obj].last.class.name.to_s.tableize.sub('/', '.')}.edit")
      @object ||= options[:obj].last
      if options[:policy_class].blank?
        authorize @object
      else
        raise Pundit::NotAuthorizedError unless "#{options[:policy_class]}Policy".constantize.new(Current, options[:security_items] || @object).send("#{context.action_name}?")
      end
      code = Proc.new do
        do_edit({
          title: context.t('.title'),
          columns: columns,
          item: @object,
          model: @object.class,
          url: context.polymorphic_url(options[:obj]), # Itt a stack level too deep
          back_url: options[:back_url].nil? ? url_for(action: :index) : options[:back_url],
          method: :post
        }.merge(options))
      end
      eval 'self', code.binding
      context.instance_eval &code
    end

    private

    attr_reader :h
  end
end
