module Authentication
  class InvitationMailer < ::ApplicationMailer
    def invite_user(invitation)
      @user = Authentication::User.find(invitation.user_id)
      @company = Authentication::Company.find(invitation.company_id)
      mail(to: invitation.email, subject: 'Meghívó') do |format|
        format.html # { render layout: 'mailer' }
        format.text
      end
    end

    def right_added_to_user(invitation)
      @user = Authentication::User.find(invitation.user_id)
      @company = Authentication::Company.find(invitation.company_id)
      mail(to: invitation.email, subject: 'Meghívó') do |format|
        format.html # { render layout: 'mailer' }
        format.text
      end      
    end
  end
end
