module Btemplater
  class ActionDecorator
    attr_reader :name, :path, :title, :icon, :method, :data, :clazz

    def initialize(name, path, title, icon, method = :get, data = {}, clazz = {})
      @name = name
      @path = path
      @title = title
      @icon = icon
      @method = method
      @data = data
      @clazz = clazz
    end
  end
end
