#include MetaTags::ViewHelper
module Btemplater
  module ApplicationHelper
    def do_title(title, titleactions = nil, smalltext = nil, env = nil, options = {})
      return '' if title.nil? && smalltext.nil?
      smalltext ||= options[:title_small]
      set_meta_tags title: title
      content_tag(options[:div] ? options[:div] : :div, class: options[:div_class] ? options[:div_class] : 'page-header') do
        concat(content_tag(:h1) do
          concat title
          concat content_tag(:small, smalltext) unless smalltext.nil?
          concat(content_tag(:div, class: 'btemplater_title_actions') do
            titleactions.each do |action|
              if action == :separator
                concat '<span class="btn-separator"></span>'.html_safe
              else
                concat action.link.call(self)
              end
            end if titleactions
          end)
        end)
        # concat(content_tag(:ol, class: 'breadcrumb') do
        #   concat(content_tag(:li) do
        #     '<a href="#"><i class="fa fa-dashboard"></i> Home</a>'.html_safe
        #   end)
        #   concat(content_tag(:li, class: 'active') do
        #     'Dashboard'
        #   end)
        # end)
        concat(content_tag(:hr, class: 'title_br') do
        end)
      end
    end
  end
end
