module Btemplater
  module EditHelper
    include ApplicationHelper
    include ActionView::Helpers::TagHelper

    def do_edit(args, env = nil)
      puts args.inspect
      model_name = args[:item].is_a?(Array) ? args[:item].last.class : args[:item].class
      puts model_name.class
      puts "22"
      puts model_name.class.name
      if model_name.class.name == 'Class'
        puts args[:obj].last.class.name
        model_name = args[:obj].last.class
      end
      if args[:policy_class]
        policy_name = "#{args[:policy_class]}Policy".constantize
      else
        policy_name = "#{model_name.name.to_s}Policy".constantize
      end
      security_items = args[:security_items] || args[:item]
      if policy_name.blank?
        authorize (security_items), :edit?
      else
        puts policy_name
        puts "//"
        skip_authorization
        if security_items.nil?
          puts "aha"
          security_items = model_name
        end
        raise Pundit::NotAuthorizedError unless policy_name.new(Current, security_items).edit?
      end

      # raise Pundit::NotAuthorizedError unless policy_name.new(Btemplater::Engine.config.current_user_entity.call(self), security_items).edit?
      args.merge(
        title: [],
        columns: [],
        items: [],
        model: nil,
        url: nil,
        method: :get,
        form_bottom: nil,
        form_params: { class: 'form-horizontal' }
      )
      capture do
        concat(render(args[:form_pre])) if args[:form_pre]
        concat do_title(args[:title], nil, args[:title_small], env, args)
        concat(simple_form_for(args[:item], html: args[:form_params], url: args[:url], post: args[:method]) do |f|
                concat(content_tag(:div, class: 'inputs') do
                                  args[:columns].each do |column|
                                    if column.instance_of? Btemplater::NewDecorator
                                      concat column.decorator.call(f, column)
                                    else
                                      concat f.input column
                                    end
                                  end
                                end)
                    concat(render(args[:form_bottom], f: f)) if args[:form_bottom]
                    concat(content_tag(:div, class: 'actions') do
                                          if args[:submit_button_text] == false
                                          elsif !args[:submit_button_text].nil?
                                            concat f.submit args[:submit_button_text], class: 'btn btn-primary'
                                          else
                                            concat f.submit I18n.t('btemplater.actions.edit', model: args[:obj].last.model_name.human).humanize, class: 'btn btn-primary'
                                          end

                                          concat link_to t('cancel', scope: :btemplater), args[:back_url], class: 'btn btn-secondary'
                                        end)
                end)
        concat(render(args[:form_post])) if args[:form_post]
      end
    end
  end
end
