module Btemplater
  module IndexSearchHelper
    def search(args, current_user_entity, env)
      # yield

      # model_name = args[:model].to_s
      # model_name = args[:model].try(:first).to_s if args[:model].is_a?(Array)

      #cont = env.content_tag :table, class: "table table-hover table-striped #{model_name.underscore.gsub('/', '_')}" do
      #  thead(args, env) + tbody(args, current_user_entity, env)
      #end

      search_args = args.try('[]', :args).try('[]', 0)
      search_fields = args.try('[]', :fields)
      return '' unless search_fields
      
      search_dialog = render 'btemplater/shared/search_dialog', env: env, fields: search_fields, args: search_args

      search_str  = search_dialog
      search_str += "<button id=\"search_button\" onclick=\"$('#searchmodal').modal('show');\" class=\"btn btn-info\">Keresés megjelenítése...</button>".html_safe
      search_str += "&nbsp;#{search_active(env.params)}".html_safe

      return search_str.html_safe
    end

    def search_active(params)
      search_params = params[:search]
      if search_params
        i = 0
        search_params.each do |prm|
          i = search_params_helper(prm[0].to_sym, search_params, i)
        end
        return '' if i == 0
        str = '<span class="badge badge-warning">' + i.to_s + ' keresési feltétel aktív</span>'
        return str.html_safe
      else
        return ''
      end
    end

    def search_params_helper(field, search_params, i, truevalue = nil)
      if truevalue.nil?
        if !search_params[field].blank?
          i += 1
        end
      else
        if search_params[field] == truevalue
          i += 1
        end
      end
      return i
    end

    # def column(name, value = nil, &block)
    #   value = name unless value
    #   @columns << { name: name, value: value, block: block }
    # end

    # def show_action(args, item, right = true, env = nil)
    #   env.link_to env.polymorphic_url(args[:class].map{|m| m.to_s.demodulize.tableize.singularize}, id: item.id), class: 'btn btn-secondary', title: I18n.t('actions.show', scope: :btemplater) do
    #     env.content_tag(:span, '', class: 'fa fa-file')
    #   end.html_safe if right
    # end

    # def edit_action(args, item, right = true, env = nil)
    #   po = args[:parentobj] ? args[:parentobj].dup : []
    #   env.link_to env.polymorphic_url((po << item).flatten, {action: :edit}.merge(args[:options] || {})), class: 'btn btn-warning', title: I18n.t('actions.edit_short', scope: :btemplater) do
    #     env.content_tag(:span, '', class: 'fa fa-pencil-square-o')
    #   end.html_safe if right
    # end

    # def destroy_action(args, item, right = true, env = nil, confirm_message = I18n.t('actions.are_you_sure', scope: :btemplater))
    #   po = args[:parentobj] ? args[:parentobj].dup : []
    #   env.link_to env.polymorphic_url((po << item).flatten, {}.merge(args[:options] || {})), class: 'btn btn-danger', title: I18n.t('actions.destroy', scope: :btemplater), method: :delete, data: { confirm: confirm_message } do
    #     env.content_tag(:span, args[:text].blank? ? '' : " #{args[:text]}", class: 'fa fa-trash')
    #   end.html_safe if right
    # end

    # def action_decorator(ad, item, policy = true, env = nil, clazz = nil)
    #   env.link_to ad.path.call(item), class: (ad.clazz.blank? ? 'btn btn-secondary' : ad.clazz), title: ad.title, method: ad.method, data: ad.data do
    #     if ad.icon.class == Proc
    #       env.content_tag(:span, '', class: "fa fa-#{ad.icon.call(item)}")
    #     else
    #       env.content_tag(:span, '', class: "fa fa-#{ad.icon}")
    #     end
    #   end.html_safe
    # end

    # def thead(args, env = nil)
    #   env.content_tag :thead do
    #     env.content_tag :tr do
    #       @columns.each do |c|
    #         env.concat(env.content_tag(:th, c[:value], class: c[:name]))
    #       end
    #       env.concat(env.content_tag(:th, '')) unless args[:actions].empty?
    #     end
    #   end
    # end

    # def tbody(args, current_user_entity, env = nil)
    #   items = args[:items]
    #   if items.count == 0
    #     env.content_tag :tbody do
    #       if args[:empty_partial]
    #         env.render args[:empty_partial]
    #       elsif args[:empty_text]
    #         ('<tr><td colspan="999">' + args[:empty_text] + '</td></tr>').html_safe
    #       else
    #         ('<tr><td colspan="999">' + I18n.t('helpers.index.table_empty') + '</td></tr>').html_safe
    #       end
    #     end
    #   else
    #     model_name = args[:model].is_a?(Array) ? args[:model].last.to_s : args[:model].to_s
    #     env.content_tag :tbody do
    #       items.each do |item|
    #         env.concat(
    #           env.content_tag(:tr, class: (args[:rowclass].nil? ? '' : args[:rowclass].call(item))) do
    #             @columns.each do |column|
    #               css_classes = ''
    #               args[:css_classes].each do |css_class|
    #                 css_classes += " #{css_class.decorator.call(item)}"
    #               end unless args[:css_classes].nil?
    #               if column[:name].is_a? Hash
    #                 if column[:name].has_key? :date
    #                   value = item.send(column[:name][:date])
    #                   env.concat(env.content_tag(:td, value.nil? ? '' : I18n.l(value, format: :long), class: css_classes))
    #                 elsif column[:name].has_key? :date_short
    #                   value = item.send(column[:name][:date_short])
    #                   env.concat(env.content_tag(:td, value.nil? ? '' : I18n.l(value, format: :short), class: css_classes))
    #                 end
    #               elsif column[:block]
    #                 env.concat(env.content_tag(:td, column[:block].call(item.send(column[:name]), item, env), class: css_classes))
    #               else
    #                 env.concat(env.content_tag(:td, item.send(column[:name]), class: css_classes))
    #               end
    #             end
    #             env.concat(env.content_tag(:td) do
    #               args[:actions].each do |action|
    #                 policy_name = nil
    #                 if args[:policy_class]
    #                   policy_name = "#{args[:policy_class]}Policy".constantize
    #                 else
    #                   policy_name = "#{model_name}Policy".constantize
    #                 end
    #                 if action.instance_of? Btemplater::ActionDecorator
    #                   # env.concat(env.content_tag(:div, action_decorator(action, item, authorize(security_items), "#{action.name}?", env), style: 'display: inline;'))
    #                   env.concat(env.content_tag(:div, action_decorator(action, item, policy_name.new(Current, item).send("#{action.name}?"), env), style: 'display: inline;'))
    #                 else
    #                   # env.concat(env.content_tag(:div, send("#{action}_action", args, item, authorize(security_items), "#{action}?".to_sym, env), style: 'display: inline;'))
    #                   env.concat(env.content_tag(:div, send("#{action}_action", args, item, policy_name.new(Current, item).send("#{action}?"), env), style: 'display: inline;'))
    #                 end
    #               end
    #             end)
    #           end
    #         )
    #       end
    #     end
    #   end
    # end

    # def do_new_button(args, current_user_entity, params = {})
    #   model_name = args[:model].is_a?(Array) ? args[:model].last.class : args[:model].class
    #   content_tag :div do
    #     link_to t('helpers.submit.create', model: t("activerecord.models.#{model_name.model_name.to_s.tableize.singularize}")),
    #             polymorphic_url(args[:model], action: :new, params: params),
    #             class: 'btn btn-primary'
    #   end if "#{model_name}Policy".constantize.new(current_user_entity, args[:model]).new?
    # end

    # module_function :show_action
    # module_function :edit_action
    # module_function :destroy_action
    # module_function :do_new_button
    # module_function :custom_table_for
    # module_function :column
    # module_function :thead
    # module_function :tbody
    # module_function :action_decorator
  end
end
