module Authentication
  class Company < ApplicationRecord
    resourcify

    has_and_belongs_to_many :users, optional: true
    belongs_to :user
    
    validates_presence_of :name

    def self.rights
      [:admin, :member]
    end
  end
end
